.\"
.\" Copyright 2012-2013 Samy Al Bahra.
.\" Copyright 2012-2013 Shreyas Prasad.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"
.Dd April 27, 2012
.Dt CK_BITMAP_TEST 3
.Sh NAME
.Nm ck_bitmap_next
.Nd iterate to the next set bit in bitmap
.Sh LIBRARY
Concurrency Kit (libck, \-lck)
.Sh SYNOPSIS
.In ck_bitmap.h
.Ft bool
.Fn ck_bitmap_next "ck_bitmap_t *bitmap" "ck_bitmap_iterator_t iterator" "unsigned int *bit"
.Sh DESCRIPTION
The
.Fn ck_bitmap_next
function will increment the iterator object pointed to by
.Fa iterator
to point to the next set bit in the bitmap. If
.Fn ck_bitmap_next
returns
.Dv true
then the pointer pointed to by
.Fa bit
is initialized to the number of the current set bit pointed to by the
.Fa iterator
object.
.Pp
It is expected that
.Fa iterator
has been initialized using the
.Xr ck_bitmap_iterator_init 3
function.
.Sh RETURN VALUES
If
.Fn ck_bitmap_next
returns
.Dv true
then the object pointed to by
.Fa bit
contains a set bit. If
.Fn ck_bitmap_next
returns
.Dv false
then value of the object pointed to by
.Fa bit
is undefined.
.Sh ERRORS
Behavior is undefined if
.Fa iterator
or
.Fa bitmap
are uninitialized.
.Sh SEE ALSO
.Xr ck_bitmap_base 3 ,
.Xr ck_bitmap_size 3 ,
.Xr ck_bitmap_init 3 ,
.Xr ck_bitmap_set 3 ,
.Xr ck_bitmap_reset 3 ,
.Xr ck_bitmap_clear 3 ,
.Xr ck_bitmap_bits 3 ,
.Xr ck_bitmap_buffer 3 ,
.Xr ck_bitmap_iterator_init 3
.Pp
Additional information available at http://concurrencykit.org/
